/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.GrupoCortesia;
import com.rjconsultores.ventaboletos.service.GrupoCortesiasService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("editarGrupoCortesiasController")
@Scope("prototype")
public class EditarGrupoCortesiasController extends MyGenericForwardComposer {

    @Autowired
    private GrupoCortesiasService grupoCortesiasService;
    private GrupoCortesia grupoCortesia;
    private MyListbox grupoCortesiasList;
    private Textbox txtNome;
    private static Logger log = Logger.getLogger(EditarGrupoCortesiasController.class);
    private Button btnApagar;
    private Button btnSalvar;

    public GrupoCortesia getGrupoCortesia() {
        return grupoCortesia;
    }

    public void setGrupoCortesia(GrupoCortesia grupoCortesia) {
        this.grupoCortesia = grupoCortesia;
    }

    public MyListbox getGrupoCortesiasList() {
        return grupoCortesiasList;
    }

    public void setGrupoCortesiasList(MyListbox grupoCortesiasList) {
        this.grupoCortesiasList = grupoCortesiasList;
    }

    public GrupoCortesiasService getGrupoCortesiasService() {
        return grupoCortesiasService;
    }

    public void setGrupoCortesiasService(GrupoCortesiasService grupoCortesiasService) {
        this.grupoCortesiasService = grupoCortesiasService;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        grupoCortesia = (GrupoCortesia) Executions.getCurrent().getArg().get("grupoCortesia");
        grupoCortesiasList = (MyListbox) Executions.getCurrent().getArg().get("grupoCortesiaList");

        txtNome.focus();

        if (grupoCortesia.getGrupocortesiaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            if (grupoCortesia.getGrupocortesiaId() <= 3) {
                btnApagar.setVisible(Boolean.FALSE);
                btnSalvar.setVisible(Boolean.FALSE);
                txtNome.setDisabled(Boolean.TRUE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarGrupoCortesiasController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        }


    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        try {
            grupoCortesia.setActivo(Boolean.TRUE);
            grupoCortesia.setFecmodif(Calendar.getInstance().getTime());
            grupoCortesia.setUsuarioId(0);

            List<GrupoCortesia> lsGrupoCortesias = grupoCortesiasService.buscar(grupoCortesia.getDescgrupo());

            if (!lsGrupoCortesias.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarGrupoCortesiasController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (grupoCortesia.getGrupocortesiaId() == null) {
                    grupoCortesiasService.suscribir(grupoCortesia);
                    grupoCortesiasList.addItem(grupoCortesia);
                } else {
                    grupoCortesiasService.actualizacion(grupoCortesia);
                    grupoCortesiasList.updateItem(grupoCortesia);
                }

                Messagebox.show(
                        Labels.getLabel("editarGrupoCortesiasController.MSG.suscribirOK"),
                        Labels.getLabel("editarGrupoCortesiasController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);

            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarGrupoCortesiasController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);

        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarGrupoCortesiasController.MSG.BorrarPergunta"),
                    Labels.getLabel("editarGrupoCortesiasController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                grupoCortesiasService.borrar(grupoCortesia);

                Messagebox.show(
                        Labels.getLabel("editarGrupoCortesiasController.MSG.BorrarOK"),
                        Labels.getLabel("editarGrupoCortesiasController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                grupoCortesiasList.removeItem(grupoCortesia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
